--[[
CircuitBuilder creates a Circuit from Schematic.elements data to be solved
This is a bit of a mess right now :( but it works. I will try to clean it up for the next update
]]

CircuitBuilder = class()

function CircuitBuilder:init(elements)
    self.circuit = Circuit()
    self.elements = elements
end

function CircuitBuilder:buildCircuit()
    self.grounds = {}
    self.nodes = {}
    self.attachments = {}
    self.connections = {}
    self.visited = {}
    for y, row in pairs(self.elements) do
        for x, e in pairs(row) do
            if e and e.kind == "Ground" then
                table.insert(self.grounds, e)
            elseif e and e.component then
                e.component.nodes[1] = false
                e.component.nodes[-1] = false
            end
        end
    end
    if #self.grounds < 1 then
        return
    end
    local gnd = self:Node(self.circuit, "gnd")
    table.insert(self.nodes, gnd)
    for i, v in pairs(self.grounds) do
        self:attached(v, gnd)
    end
    for i, v in pairs(self.attachments) do
        if not self.visited[self:toStr(v)] then
            local node = self:Node(self.circuit, "n"..#self.nodes)
            for j = -1, 1, 2 do
                if not v.component.nodes[j] then
                    node.node:connect(v.component, j)
                end
            end
            table.insert(self.nodes, node)
            self:attached(v, node)
            self.visited[self:toStr(v)] = true
        end
    end

    -- for i, v in pairs(self.nodes) do
    --     print(v.node.name .. ":"  .. #v.wire)
    --     for j, w in pairs(v.node.connections) do
    --         print(w.sign .. "*" .. w.component.name)
    --     end
    --     for j, w in pairs(v.node.voltageConnections) do
    --         print(w.sign .. "*" .. w.component.name)
    --     end
    -- end
    local solution = self.circuit:solve(self.nodes[1].node)
    for i, node in pairs(self.nodes) do
        for j, wire in pairs(node.wire) do
            wire.voltage = node.node.voltage
        end
    end
    if solution and solution ~= "false" then
        return true
    else
        return false
    end
end

function CircuitBuilder:attached(element, node)
    local a = element:attached()
    for sign, v in pairs(a) do
        for i, e in pairs(v) do
            if e.kind == "Wire" and not self.visited[self:toStr(e)] then
                table.insert(node.wire, e)
                self.visited[self:toStr(e)] = true
                self:attached(e, node)
            elseif e.component  then
                local side = e:isAttached(element.x, element.y)*(e.inverted and -1 or 1)
                if not self.visited[self:toStr(e, side)] then
                    table.insert(self.attachments, e)
                end
                if self.visited[self:toStr(e, -side)] then
                    self.visited[self:toStr(e)] = true
                end
                if not e.component.nodes[side] then
                    node.node:connect(e.component, side)
                end
                self.visited[self:toStr(e, side)] = true
            end
        end
    end
end

function CircuitBuilder:toStr(e, sign)
    return e.x .. ", " .. e.y .. (sign and "," .. sign or "")
end

function CircuitBuilder:Node(circuit, name)
    return {wire = {}, node = Node(circuit, name), attachments = {}}
end
