Unit = class()

-- prefixes ordered by magnitude, for dropdown reference
Unit.prefixes =      { "m", "",  "k"}
Unit.prefix_values = {["m"] = -3, [""] = 0, ["k"] = 3}

function Unit:init(coeff, prefix, unit)
    self.coeff = coeff or 0
    self.prefix = prefix or ""
    self.unit = unit or ""
end

function Unit.pretty(x)
    local u = ""
    local s = 0
    for i, v in pairs(Unit.prefixes) do
        local p = Unit.prefix_values[v]
        if p < 0 then
            if math.abs(x) < math.pow(10, p)*100 then
                x = x * math.pow(10, -p)
                u = v
                break
            end
        else
            if math.abs(x) >= math.pow(10, p)/10 then
                x = x * math.pow(10, -p)*math.pow(10, s)
                s = s + p
                u = v
            end
        end
    end
    x = math.floor(x*100 + 0.5)/100
    return string.sub(tostring(x), 0, 7) .. u
end

function Unit:value()
    return self.coeff * math.pow(10, Unit.prefix_values[self.prefix])
end

function Unit:str()
    return self.coeff .. self.prefix .. self.unit
end

function Unit:unitStr()
    return self.prefix .. self.unit
end
