-- Configure Build
local includes = {"GUI/animation.lua",
                  "GUI/globals.lua",
                  "GUI/screen.lua",
                  "GUI/widgets.lua",


                  "Builder/builder.lua",
                  "Builder/widgets.lua",
                  "Builder/element.lua",
                  "Builder/schematic.lua",

                  "Solver/units.lua",
                  "Solver/circuit.lua",
                  "Solver/node.lua",
                  "Solver/component.lua",

                  "main.lua"}

local filename = "big.lua"
local apilevel = "2.0"
local nspice_version = "0.1"

-- Get contents of file
function read(file)
    local bar = "---**************************---\n"
    local content = bar .. bar .. "-- Start of new file\n"
    content = content .. "-- File: " .. file .. "\n"
    content = content .. bar .. bar .. "\n"
    local f = assert(io.open(file, "r"))
    content = content .. f:read("*all")
    f:close()
    return content
end

-- Save content to file
content = "platform.apilevel = '" .. apilevel .. "'\n"
content = content .. "nspice_version= '" .. nspice_version .. "'\n"
for _, file in pairs(includes) do
    content = content .. read(file)
end

local f = assert(io.open(filename, "w"))
f:write(content)
f:close()

print("Building successful, compilated source code located in " .. filename)
