function main()

    local main = WScreen()
    local panel = InfoPanel()
    local indicator = sLabel("")
    panel:setSize(100, 100)
    local workspace = Schematic{panel = panel, indicator = indicator}
    workspace:setSize(-1, -1)
    main:appendWidget(workspace, 0, 0)
    main:appendWidget(panel, -10, 10)
    main:appendWidget(indicator, -5, -5)
    workspace:giveFocus()

    function main:paint(gc)
        gc:setColorRGB(55, 55, 55)
        gc_clipRect(gc, "set", 0, 0, platform.window:width(), platform.window:height())
        gc:fillRect(0, 0, platform.window:width(), platform.window:height())
    end

    function main:tabKey()
        circuitThings()
    end

    function about ()
        local aboutText = {"NSPICE is a circuit design and simulation",
                           "program developed by M4dasOne",
                           "",
                           "GUI Toolkit by Adrien 'Adriweb' Betrand and",
                           "Jim Bauwens",
                           "",
                           "Special Thanks: Inspired-lua.org, TIPlanet.org",
                           "License: LGPL3"}
        local iw = InfoWindow("About NSPICE v" .. nspice_version, aboutText, 10, 10, -20, -20)
        push_screen_direct(iw)
    end

    function help ()
        local helpText = { "Be sure to connect all circuits to Ground",
                           "before solving!",
                           "",
                           "Controls",
                           "Arrows / Numpad / Mouse: Navigate",
                           "Enter / Mouse: Insert / Edit",
                           "Del: Delete",
                           "+ / - : Zoom",
                           "f / 5 : Flip component"}
        local iw = InfoWindow("Help", helpText, 10, 10, -20, -20)
        push_screen_direct(iw)
    end

    local tools = {{menuIndex = "Inspector",      tool = "inspector",   shortcut = "i"},
                   {menuIndex = "Wire Segment",   tool = "wire",        shortcut = "w"},
                   {menuIndex = "Wire Loop",      tool = "loop",        shortcut = "l"},
                   {menuIndex = "Resistor",       tool = "resistor",    shortcut = "r"},
                   {menuIndex = "Voltage Source", tool = "voltage",     shortcut = "v"},
                   {menuIndex = "Current Source", tool = "current",     shortcut = "c"},
                   {menuIndex = "Ground",         tool = "ground",      shortcut = "g"}}

    local menu = {
        {"Circuit",
            {"Solve (s)", function() workspace:solve() end},
            {"Clear (ctrl+del)", function() workspace:clearKey() end}
        },
        {"Tools"
        },
        {"Help",
            {"Help", help},
            {"About", about},
        }
    }

    local toolLookup = {}

    function setTool (parent, option)
        workspace.tool = toolLookup[option]
    end

    for i, v in ipairs(tools) do
        local m = v.menuIndex
        if v.shortcut then
            m = m .. " (" .. v.shortcut .. ")"
            workspace.toolShortcuts[v.shortcut] = v.tool
        end
        table.insert(menu[2], {m, setTool})
        toolLookup[m] = v.tool
    end

    toolpalette.register(menu)
    push_screen(main)

end

main()
